=== debian/changelog ===
gxlimg (0.0.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1121474)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 27 Nov 2025 09:55:16 +0100
