=== debian/control ===
Source: gxlimg
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Section: utils
Priority: optional
Homepage: https://github.com/repk/gxlimg/
Vcs-Browser: https://salsa.debian.org/debian/gxlimg
Vcs-Git: https://salsa.debian.org/debian/gxlimg.git
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 libssl-dev,
 meson,
 pkgconf,

Package: gxlimg
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: amlogic s905x boot image creation tool
 Reverse engineered aml_encrypt_gxl binary used to create boot image as
 well as the BL2 arm binary that reads FIP header and loads BL3* and
 u-boot images.
